unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, UTurtle, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Turtle1: TTurtle;
    Button2: TButton;
    ScrollBar1: TScrollBar;
    Button3: TButton;
    ScrollBar2: TScrollBar;
    ScrollBar3: TScrollBar;
    ScrollBar4: TScrollBar;
    Timer1: TTimer;
    Button4: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Baum(n,l,p1,p2, p3, p4 : Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  timer1.Enabled:= false;
  turtle1.MoveTo(250,475);
  turtle1.Turn(90);
end;

Procedure TForm1.baum(n,l,p1, p2, p3, p4 : Integer);
Begin
  If n>0 Then
  begin
    with turtle1 do
    begin
      draw(l);
      turn(p1);
      baum(n-1, l * p3 div 100,p1, p2, p3, p4);
      turn(-(p1));
      turn(-(p2));
      baum(n-1, l * p4 div 100,p1, p2, p3 ,p4);
      turn(p2);
      move(-l);
      end;

  end;
End;

procedure TForm1.Button1Click(Sender: TObject);
begin
  timer1.Enabled:=false;
  baum(strtoint(edit1.text),strtoint(edit2.text), scrollbar1.Position, scrollbar2.Position, scrollbar3.Position, scrollbar4.Position);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  turtle1.clear;
  timer1.Enabled:=false;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  a,b,c,d: Integer;
begin
  a:= Random(121) -60;
  b:= Random(121) -60;
  c:= Random(80) +21;
  d:= Random(80) +21;

  turtle1.Clear;

  baum(strtoint(edit1.text),strtoint(edit2.text), a, b, c, d);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  timer1.Interval := 500;
  timer1.Enabled:=true;
end;

end.
